CON
	
	#0, THINKING, HUNGRY, EATING, STARVED
	#0, RANDOM, LAZY, SYNC

VAR
	long	stack[32]
	long	rnd
	byte	gLeft, gRight
	byte	gHaveLeft, gHaveRight
	byte	gState
	byte	gTime
	
PUB start(num)
	gLeft := num
	gRight := num + 1
	if (gRight > 4)
		gRight := 0
	rnd := CNT
	cogNew(run, @stack)

PUB setMode(m)
	mode := m

PUB getState
	return gState

PUB hasLeft
	return gHaveLeft

PUB hasRight
	return gHaveRight

PUB getLeft
	return gLeft

PUB getRight
	return gRight


PRI run
	REPEAT
		case gState
			THINKING:
				think
			HUNGRY :
				takeForks
			EATING :
				eat
			STARVED :
				doNothing

PRI think : t | dt
	case mode
		RANDOM:
			t := cnt
			dt := CLKFREQ * 3 + (?rnd >> 5)
			repeat
				if mode <> RANDOM
					quit
			until cnt -t > dt
		SYNC:
			repeat
				repeat until not lockset(5)
				t := mask
				lockclr(5)
				if mask == $1F
					waitcnt(syncat)
					quit
	gState := HUNGRY

PRI takeForks : m
	m := mode
	repeat
		if m <> mode
			return
	until not lockset(gLeft)
	gHaveLeft := 1
	repeat 
		if m <> mode
			gHaveLeft := 0
			lockClr(gLeft)
			return
	until not lockset(gRight)
	gHaveRight := 1
	gState := EATING
	
PRI eat : t | dt, m
	m := mode
	t := cnt
	dt := CLKFREQ * 3 + (?rnd >> 5)
	repeat
		if mode <> m
			quit
	until cnt -t > dt
	gHaveLeft := 0
	gHaveRight := 0
	gState := THINKING
	lockClr(gLeft)
	lockClr(gRight)
	if mode == SYNC
		repeat until not lockset(5)
		mask |= |< gLeft
		if mask == $1F
			syncat := CNT + CLKFREQ / 3
		lockClr(5)

PRI doNothing
	REPEAT
		WAITCNT(cnt)

DAT

	mode	long	RANDOM
	mask	long	0
	syncat	long	0
